// hash function to get a random number of a 2d coordinate -> return value between 0 and 1
float N21(float2 p) {
    p = frac(p * float2(123.34, 345.45));
    p += dot(p, p + 34.345);
    return frac(p.x * p.y);
}
